<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <script>
        var partidos = [];
        window.onload = function(){
            //Cargamos los datos desde Ajax accediendo al archivo XML
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function(){
                if(xhr.readyState == 4 && xhr.status == 200){
                    //En this.responseXML tengo todos los datos
                    var datos = this.responseXML; 
                    //Nombre del municipio
                    document.getElementById('municipio').innerHTML = datos.getElementsByTagName("nombre_sitio")[0].firstChild.nodeValue;
                    document.getElementById('h1').style.textAlign = 'center';
                    //Cargamos el array de partidos
                    var listaPartidos = datos.getElementsByTagName("partido");
                    for(var i = 0; i < listaPartidos.length; i++){
                        var partidoNombre = listaPartidos[i].getElementsByTagName("nombre")[0].firstChild.nodeValue;
                        var votos = Number(listaPartidos[i].getElementsByTagName("votos_numero")[0].firstChild.nodeValue);
                        //Inserto un elemento
                        partidos.push({partido: partidoNombre, Votos: votos, escanno: 0});
                    }
                    RepartoDhont(partidos, 109);
                    muestraPorPantalla(partidos);
                }
            }
            xhr.open("GET", "elecciones.xml", true);
            xhr.send();
        }
        
        function RepartoDhont(partidos, totalescanno) {
            //Ordenamos el array del partido por números de votos descendente.
            partidos.sort(function (a, b) {
                if (a.Votos > b.Votos) return -1;
                if (a.Votos < b.Votos) return 1;
                if (a.Votos == b.Votos) return 0;
            });
            //Creamos el array bidemesional para el reparto
            var dhont = [];
            for (var f = 0; f < partidos.length; f++) {
                partidos[f].escanno = 0;
                dhont[f] = [];
                for (var c = 0; c < totalescanno; c++) {
                    dhont[f][c] = partidos[f].Votos / (c + 1);
                }
            }
            //Buscamos los primeros N máximos

            for (var veces = 0; veces < totalescanno; veces++) {
                var indiceMayor = 0;
                for (var f = 0; f < partidos.length; f++) {
                    if(dhont[f][partidos[f].escanno]> dhont[indiceMayor][partidos[indiceMayor].escanno]){
                        indiceMayor = f;
                    }
                }
                partidos[indiceMayor].escanno++;
            }
        }

        function muestraPorPantalla(partidos){
            var salida = "<table border='1'>";
            salida +='<tr><th> Partido </th><th> Votos </th><th> Escaños </th></tr>'
            for (var i = 0; i < partidos.length; i++) {   
                salida += "<tr><td>" + partidos[i].partido + "</td><td><input type='number' id='" + i + "' value='" + partidos[i].Votos + "'/></td><td>" + partidos[i].escanno + "</td></tr>"
            }
            salida += "</table>";
            document.getElementById('reparto').innerHTML = salida;
            var inputs = document.getElementsByTagName('input');
            for(var i = 0; i < inputs.length; i++){
                inputs[i].onchange = function(){
                    partidos[this.id].Votos = Number(this.value);
                    RepartoDhont(partidos, 109);
                    muestraPorPantalla(partidos);
                }
            }
        }
    </script>
</head>
<body>
    <h1 id="h1">Elecciones electorales <span id="municipio"></span></h1>
    <div id="reparto"></div>
</body>
</html>